"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("isomorphic-fetch");

var _nodeFetch = _interopRequireDefault(require("node-fetch"));

var _bluebird = _interopRequireDefault(require("bluebird"));

_nodeFetch.default.Promise = _bluebird.default;

class Connector {
  constructor({
    debug,
    httpsAgent,
    timeout = Number(process.env.FETCH_TIMEOUT) || Number(process.env.TIMEOUT) || 1000
  }) {
    this.debug = debug;
    this.httpsAgent = httpsAgent;
    this.timeout = timeout;
  }

  fetch(url, request, responseType = 'json') {
    this.debug('%j', {
      url,
      responseType,
      agent: this.httpsAgent,
      timeout: this.timeout,
      ...request
    });
    return fetch(url, {
      agent: this.httpsAgent,
      timeout: this.timeout,
      ...request
    }).tap(this.debug).then(res => res[responseType]()).tap(this.debug).tapCatch(this.debug);
  }

}

var _default = Connector;
exports.default = _default;